//	Ella Roubtsova

package KPI3;

import com.metamaxim.modelscope.callbacks.*;
import java.util.*;



public class DashboardRecovery extends Behaviour {	  

public Date getStartOfReportingQuarter(){
			Calendar cal=Calendar.getInstance();
			Date StartQuarter = this. getDate("StartOfReportingQuarter"); 
			cal.setTime(StartQuarter);
			return StartOfReportingQuarter;
}	
public Date getEndQuarter(){
			Calendar cal=Calendar.getInstance();
			Date StartQuarter = this. getDate("StartOfReportingQuarter"); 
			cal.add(Calendar.MONTH, 3); 
			Date EndOfReportingQuarter=cal.getTime();;
			return EndOfReportingQuarter;
}			

// KPI 5 Number of People Completed Treatment in the reported quarter
public int  getNumberOfCompletedTreatment() {
		int NumberOfCompletedTreatment=0;
					
			Date StartRQ = getStartQuarter();
			Date EndRQ=getEndQuarter();
					
		Instance[] completedTreatment =   selectInState("ReferredPerson", "referred"); 
		for (int i = 0; i < completedTreatment.length; i++) {
		  Date completionDate=completedTreatment[i].getDate("DateOfCompletion");
		  String treatmentState = completedTreatment[i].getState("Treatment") ;
		  if (completionDate.compareTo(StartRQ)>=0 && completionDate.compareTo(EndRQ)<=0 && treatmentState.equals("completed"))		
			NumberOfCompletedTreatment+=1;
			}
		  return NumberOfCompletedTreatment;	
		  }		

// KPI 6 Number of People Moving To Recovery 
public int  getNumberOfPeopleMovingToRecovery() {
		int NumberOfPeopleMovingToRecovery=0;
		
			Date StartRQ = getStartOfReportingQuarter();
			Date EndRQ=getEndOfReportingQuarter();
		
		Instance[] completedTreatment =   selectInState("ReferredPerson", "referred"); 
		for (int i = 0; i < completedTreatment.length; i++) 
		{  Date completionDate=completedTreatment[i].getDate("DateOfReferring");
		  String treatmentState = completedTreatment[i].getState("Treatment");
		   Boolean CA=completedTreatment[i].getBoolean("CasenessAfter");
		   Boolean CB=completedTreatment[i].getBoolean("CasenessBefore");
		  if (completionDate.compareTo(StartRQ)>=0 && completionDate.compareTo(EndRQ)<=0 
		  && treatmentState.equals("completed") && CB==false && CA==true )		
			NumberOfPeopleMovingToRecovery+=1;
			}
			
		  return NumberOfPeopleMovingToRecovery;	
		  }	

// KPI 6b NumberOfCasenessPeopleBeforeTreatment from the referred persons from the begin of reported quarter
public int  getNumberOfCasenessPeopleBeforeTreatment () {
		int NumberOfCasenessPeopleBeforeTreatment=0;
		
			Date StartRQ = getStartQuarter();
			Date EndRQ=getEndQuarter();
			
		Instance[] completedTreatment =   selectInState("ReferredPerson", "referred"); 
		for (int i = 0; i < completedTreatment.length; i++) 
		{
		  Date completionDate=completedTreatment[i].getDate("DateOfReferring");
		  String treatmentState = completedTreatment[i].getState("Treatment");
		  Boolean CB=completedTreatment[i].getBoolean("CasenessBefore");
		  if (completionDate.compareTo(StartRQ)>=0 && completionDate.compareTo(EndRQ)<=0 && treatmentState.equals("completed") && CB==true)		
			NumberOfCasenessPeopleBeforeTreatment+=1;
			}
		  return NumberOfCasenessPeopleBeforeTreatment;	
		  }	

// HI2 Recovery Rate KPI6/(KPI5-KP6b )
		  		  
public int  getRecoveryRate() {  
     int zn=(this.getInteger("NumberOfCompletedTreatment")-
	 this.getInteger("NumberOfCasenessPeopleBeforeTreatment"));
   int RecoveryRate=0;
   if (zn==0){ 
	RecoveryRate=0;
	}
	else 
     { 
	 RecoveryRate =  (100*this.getInteger("NumberOfPeopleMovingToRecovery"))/ zn;
	 }
	return 	RecoveryRate;	
		  }			  
		}	
	
 